明经CAD社区

 找回密码
 注册

扫一扫,访问微社区

QQ登录

只需一步,快速开始

查看: 403|回复: 3

[源码] entmake生成圆环

[复制链接]
发表于 2019-8-12 10:56 | 显示全部楼层 |阅读模式
本帖最后由 ljxkm 于 2019-8-14 09:05 编辑

生成圆环:
在实际绘图中,钢筋点筋的绘制采用绘制圆环“_donut”命令,该命令用lisp编程时没有对应的函数,采用command函数调用“_donut”命令总是不爽,故写了一个函数,采用entmake生成圆环:
;;;;;; (emdonut d1 d2 p) 绘制填充的圆环
;;;;;;参数: d1内径、d2外径、p圆心点(三维点),d1=d2>0时为直径为d1的园
;;;;;示例:(emdonut  0  5  ‘(0 00))在(0 0 0)点生成直径为5的填充的圆
;;;;;  (emdonut  5  5  ‘(0 0 0))在(0 0 0)点生成直径为5的"LWPOLYLINE"圆,"LWPOLYLINE"宽度为零

Dxf码的ENTITIES 段"LWPOLYLINE"组码值含义如下:

组码值        说明

100  
子类标记 (AcDbPolyline)
  
90  
顶点数
  
70  
多段线标志(按位编码);默认值为 01 = 关闭;128 = Plinegen
  
43  
固定宽度(可选;默认值 = 0)。如果设置为可变宽度(代码 40 / 41),则不使用
  
  
38
  
  
标高(可选;默认值 = 0)
  
39  
厚度(可选;默认值 = 0)
  
10  
顶点坐标(在 OCS 中),多个条目;每个顶点一个条目 DXF:X 值;APP:二维点
  
20  
  DXF:顶点坐标的  Y 值(在 OCS 中),多个条目;每个顶点一个条目
  
40  
  起点宽度(多个条目;每个顶点一个条目)(可选;默认值 = 0;多个条目)。如果设置为固定宽度(代码 43),则不使用
  
41  
  端点宽度(多个条目;每个顶点一个条目)(可选;默认值 = 0;多个条目)。如果设置为固定宽度(代码 43),则不使用
  
42  
  凸度(多个条目;每个顶点一个条目)(可选;默认值 = 0)
  
210  
  拉伸方向(可选;默认值 = 0, 0, 1)  DXF:X 值;APP:三维矢量
  
220,230  
  DXF:拉伸方向的  Y 值和 Z 值(可选)
  


本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有帐号?注册

x

评分

参与人数 1明经币 +1 收起 理由
VBALISPER + 1 赞一个!

查看全部评分

发表于 2019-8-12 11:01 | 显示全部楼层
谢谢分享啊   
发表于 2019-8-12 13:25 | 显示全部楼层
本帖最后由 xyp1964 于 2019-8-12 13:27 编辑

  1. ;; (ComDonut 100 200 '(0 0))
  2. (defun ComDonut (r1 r2 pt)
  3.   (cond ((< 0 r1 r2) (command "donut" r1 r2 "non" pt ""))
  4.         ( (<= 0 r2 r1) (command "donut" r1 r1 "non" pt ""))
  5.   )
  6.   (entlast)
  7. )
 楼主| 发表于 2019-8-12 15:31 | 显示全部楼层
版主的简洁啊
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号  
©2000-2017 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2019-12-14 06:00 , Processed in 0.258141 second(s), 32 queries , Gzip On.

Powered by Discuz! X3.3

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表